
package de.ivu.elect.presentation.wahlbeteiligung;

import javax.annotation.Nullable;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungAuswertung;
import de.ivu.elect.business.wahlbeteiligung.entity.WahlbeteiligungAuswertungProperties;
import de.ivu.elect.jee.faces.PreConditionCheck;
import de.ivu.elect.jee.presentation.dynamicform.FormBuilder;
import de.ivu.elect.presentation.View;
import de.ivu.elect.presentation.hilfe.OnlineHilfeId;
import de.ivu.elect.presentation.security.AbstractGebietSecurityFilter;

@OnlineHilfeId("700")
@ViewAccessScoped
@Named(AbstractWahlbeteiligungAuswertungSearchView.COMPONENT_NAME)
@View(viewId = AbstractWahlbeteiligungAuswertungSearchView.VIEW_ID, useCase = UseCasePermission.WAHLBETEILIGUNG_AUSWERTUNG_SEARCH)
public class WahlbeteiligungAuswertungSearchView extends AbstractWahlbeteiligungAuswertungSearchView {

  private static final long serialVersionUID = 1L;

  public WahlbeteiligungAuswertungSearchView() {
    super();
  }

  @Nullable
  @PreConditionCheck
  public String checkCondition() {
    if (!isWahlSelected()) {
      return getStartViewId();
    }

    return null;
  }

  @Override
  protected AbstractGebietSecurityFilter<WahlbeteiligungAuswertung> getGebietSecurityFilter() {
    return KEIN_GEBIET_SECURITY_FILTER;
  }

  @Override
  public void presetSearchParameters() {
    getSearchParameters().setWahl(getSelectedWahl());
  }

  @Override
  public void addProperties(FormBuilder formBuilder) {
    WahlbeteiligungAuswertungProperties properties = getSearchParameters().getWahlbeteiligungAuswertung().getProperties();
    formBuilder.addProperty(properties.getTypMitLeererAuswahlProperty()).withRequired(false);
    formBuilder.addProperty(properties.getStatusMitLeererAuswahlProperty()).withRequired(false);
  }
}
